export declare type tap = 'tap' | '';
export declare type bounceOptions = Partial<BounceConfig> | boolean;
export declare type dblclickOptions = Partial<DblclickConfig> | boolean;
export interface BounceConfig {
    top: boolean;
    bottom: boolean;
    left: boolean;
    right: boolean;
}
export interface DblclickConfig {
    delay: number;
}
export declare class Options {
    [key: string]: any;
    startX: number;
    startY: number;
    scrollX: boolean;
    scrollY: boolean;
    freeScroll: boolean;
    directionLockThreshold: number;
    eventPassthrough: string;
    click: boolean;
    tap: tap;
    bounce: bounceOptions;
    bounceTime: number;
    momentum: boolean;
    momentumLimitTime: number;
    momentumLimitDistance: number;
    swipeTime: number;
    swipeBounceTime: number;
    deceleration: number;
    flickLimitTime: number;
    flickLimitDistance: number;
    resizePolling: number;
    probeType: number;
    stopPropagation: boolean;
    preventDefault: boolean;
    preventDefaultException: {
        tagName?: RegExp;
        className?: RegExp;
    };
    tagException: {
        tagName?: RegExp;
        className?: RegExp;
    };
    HWCompositing: boolean;
    useTransition: boolean;
    bindToWrapper: boolean;
    disableMouse: boolean | '';
    disableTouch: boolean;
    autoBlur: boolean;
    translateZ: string;
    dblclick: dblclickOptions;
    constructor();
    merge(options?: {
        [key: string]: any;
    }): this;
    process(): this;
}
