import { EaseFn, safeCSSStyleDeclaration, EventEmitter } from '@better-scroll/shared-utils';
import Translater, { TranslaterPoint } from '../translater';
export declare type Displacement = [number, number];
export default abstract class Base {
    content: HTMLElement;
    translater: Translater;
    options: {
        probeType: number;
    };
    style: safeCSSStyleDeclaration;
    hooks: EventEmitter;
    timer: number;
    pending: boolean;
    forceStopped: boolean;
    _reflow: number;
    [key: string]: any;
    constructor(content: HTMLElement, translater: Translater, options: {
        probeType: number;
    });
    translate(endPoint: TranslaterPoint): void;
    setPending(pending: boolean): void;
    setForceStopped(forceStopped: boolean): void;
    abstract move(startPoint: TranslaterPoint, endPoint: TranslaterPoint, time: number, easing: string | EaseFn, isSilent?: boolean): void;
    abstract stop(): void;
    destroy(): void;
}
