import { EventRegister, EventEmitter } from '@better-scroll/shared-utils';
import { Options as BScrollOptions } from '../Options';
declare type Exception = {
    tagName?: RegExp;
    className?: RegExp;
};
export interface Options {
    [key: string]: boolean | number | Exception;
    click: boolean;
    bindToWrapper: boolean;
    disableMouse: boolean;
    disableTouch: boolean;
    preventDefault: boolean;
    stopPropagation: boolean;
    preventDefaultException: Exception;
    tagException: Exception;
    momentumLimitDistance: number;
}
export default class ActionsHandler {
    wrapper: HTMLElement;
    options: Options;
    hooks: EventEmitter;
    initiated: number;
    pointX: number;
    pointY: number;
    wrapperEventRegister: EventRegister;
    targetEventRegister: EventRegister;
    constructor(wrapper: HTMLElement, options: Options);
    setOptions(options: BScrollOptions): void;
    private handleDOMEvents;
    private beforeHandler;
    setInitiated(type?: number): void;
    private start;
    private move;
    private end;
    private click;
    destroy(): void;
}
export {};
