import ActionsHandler from '../base/ActionsHandler';
import Translater, { TranslaterPoint } from '../translater';
import { Animater } from '../animater';
import { Options as BScrollOptions } from '../Options';
import Behavior from './Behavior';
import ScrollerActions from './Actions';
import { EaseItem, EventEmitter, EventRegister } from '@better-scroll/shared-utils';
export interface MountedBScrollHTMLElement extends HTMLElement {
    isBScrollContainer?: boolean;
}
export default class Scroller {
    wrapper: HTMLElement;
    content: HTMLElement;
    actionsHandler: ActionsHandler;
    translater: Translater;
    animater: Animater;
    scrollBehaviorX: Behavior;
    scrollBehaviorY: Behavior;
    actions: ScrollerActions;
    hooks: EventEmitter;
    resizeRegister: EventRegister;
    transitionEndRegister: EventRegister;
    options: BScrollOptions;
    wrapperOffset: {
        left: number;
        top: number;
    };
    resizeTimeout: number;
    lastClickTime: number | null;
    [key: string]: any;
    constructor(wrapper: HTMLElement, options: BScrollOptions);
    private init;
    setOptions(options: BScrollOptions): void;
    private bindTranslater;
    private bindAnimater;
    private bindActions;
    private checkFlick;
    private momentum;
    private checkClick;
    private resize;
    private transitionEnd;
    private togglePointerEvents;
    refresh(): void;
    scrollBy(deltaX: number, deltaY: number, time?: number, easing?: EaseItem): void;
    scrollTo(x: number, y: number, time?: number, easing?: EaseItem, extraTransform?: {
        start: {};
        end: {};
    }, isSilent?: boolean): void;
    scrollToElement(el: HTMLElement | string, time: number, offsetX: number | boolean, offsetY: number | boolean, easing?: EaseItem): void;
    resetPosition(time?: number, easing?: EaseItem): boolean;
    updatePositions(pos: TranslaterPoint): void;
    getCurrentPos(): TranslaterPoint;
    enable(): void;
    disable(): void;
    destroy(this: Scroller): void;
}
